
;config default= 144.100 Mhz ref = 25Mhz  internal load 8pF
#include "p12f675.inc" 

 __CONFIG _FOSC_INTRCIO & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _BOREN_ON & _CP_OFF & _CPD_OFF
		  

SDA1	equ	0x04		
SCL	equ	0x02				   

count			     equ 42h   
temp			     equ 43h    
bytcnt			     equ 44h   
ebyte			     equ 45h     
	     

                org 0
		goto start	
		
		
start		clrf GPIO
		bcf STATUS,RP0
		clrf GPIO		
		bsf STATUS,RP0
		movlw b'0000000'   
		movwf ANSEL 
		movlw b'00001000'
		movwf TRISIO					
		bcf STATUS,RP0
		movlw d'7'
		movwf CMCON  	
		bsf STATUS,RP0		
	        bcf OPTION_REG,NOT_GPPU
		bcf STATUS,RP0
		bsf  GPIO,SDA1	
	        bcf  GPIO,SCL	
	        call wait_10ms
		call init_si5351A
		call prog_registers
		goto $		
		
	
prog_registers	call openw_1		
	        movlw d'15'		
		movwf ebyte
		call putbyte_1       	
	        movlw h'00'		; Register 15   
	        movwf ebyte            
	        call putbyte_1	
	        movlw h'4F'		; Register 16 
	        movwf ebyte            
	        call putbyte_1	
                movlw h'8C'		; Register 17
                movwf ebyte
                call putbyte_1	
                movlw h'8C'		; Register 18
	        movwf ebyte
		call putbyte_1	
		movlw h'8C'		; Register 19
		movwf ebyte
		call putbyte_1	
		movlw h'8C'		; Register 20
		movwf ebyte
		call putbyte_1	
		movlw h'8C'		; Register 21
		movwf ebyte
		call putbyte_1	
		movlw h'8C'		; Register 22
		movwf ebyte
		call putbyte_1	
		movlw h'8C'		; Register 23
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 24 
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 25
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 26
		movwf ebyte
		call putbyte_1	
		movlw h'7D'		; Register 27
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 28
		movwf ebyte
		call putbyte_1	
		movlw h'0F'		; Register 29
		movwf ebyte
		call putbyte_1	
		movlw h'4A'		; Register 30
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 31
		movwf ebyte
		call putbyte_1
		movlw h'00'		; Register 32
		movwf ebyte
		call putbyte_1	
		movlw h'5E'		; Register 33
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 34
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 35
		movwf ebyte
		call putbyte_1
		movlw h'00'		; Register 36
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 37
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 38
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 39
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 40
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 41
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 42
		movwf ebyte
		call putbyte_1	
		movlw h'01'		; Register 43
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 44
		movwf ebyte
		call putbyte_1	
		movlw h'01'		; Register 45
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 46
		movwf ebyte
		call putbyte_1
		movlw h'00'		; Register 47
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 48
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 49
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 50
		movwf ebyte
	        call putbyte_1		
	        movlw h'00'		; Register 51
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 52
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 53
		movwf ebyte
		call putbyte_1		
	        movlw h'00'		; Register 54
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 55
		movwf ebyte
		call putbyte_1		
	        movlw h'00'		; Register 56
		movwf ebyte
	        call putbyte_1		
		movlw h'00'		; Register 57
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 58
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 59
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 60	
	    	movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 61
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 62
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 63
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 64
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 65
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 66
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 67
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 68
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 69
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 70
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 71
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 72
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 73
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 74
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 75
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 76
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 77
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 78
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 79
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 80
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 81
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 82
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 83
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 84
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 85
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 86
		movwf ebyte
		call putbyte_1		
		movlw h'00'		; Register 87
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 88
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 89
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 90
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 91
		movwf ebyte
	        call putbyte_1	
		movlw h'00'		; Register 92
		movwf ebyte
		call stop_1
		
		call openw_1		
		movlw d'149'		
		movwf ebyte
		call putbyte_1			
		movlw h'00'		; Register 149
		movwf ebyte
	        call putbyte_1	
		movlw h'00'		; Register 150
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 151
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 152
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 153
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 154
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 155
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 156
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 157
		movwf ebyte
		call putbyte_1
		movlw h'00'		; Register 158
		movwf ebyte
		call putbyte_1
		movlw h'00'		; Register 159
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 160
		movwf ebyte
		call putbyte_1
		movlw h'00'		; Register 161
		movwf ebyte
		call putbyte_1
		movlw h'00'		; Register 162
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 163
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 164
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 165
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 166
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 167
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 168
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 169
		movwf ebyte
		call putbyte_1	
		movlw h'00'		; Register 170	
		movwf ebyte
		call putbyte_1
		call stop_1		
		call openw_1		
		movlw d'177'		
		movwf ebyte
		call putbyte_1		
		movlw H'AC'		
		movwf ebyte
		call putbyte_1		
		call stop_1	
		call openw_1		
		movlw d'3'		
		movwf ebyte
		call putbyte_1
		movlw b'11111000'	
		movwf ebyte
		call putbyte_1			
		call stop_1
		return
		
init_si5351A	call openw_1		
		movlw d'3'		
		movwf ebyte
		call putbyte_1		
		movlw H'FF'		
		movwf ebyte
		call putbyte_1		
		call stop_1		
		call openw_1		
		movlw d'187'		
		movwf ebyte
		call putbyte_1		
		clrf ebyte		
		call putbyte_1		
		call stop_1		
		call openw_1		
		movlw d'16'		
		movwf ebyte
		call putbyte_1		
		movlw d'8'		
		movwf temp
		movlw H'80'		
		movwf ebyte
		call putbyte_1		
	        decfsz temp,f
		goto $-4
		call stop_1		
		call openw_1		
		movlw d'183'		
		movwf ebyte
		call putbyte_1        
		movlw H'92'	                     ; Register 183
		movwf ebyte
		call putbyte_1		
		call stop_1		
		return 
	
	


; *******************************************************************************
; Open for write
openw_1
	call	i2cstart_1
	movlw	H'C0'		; Send Si5351 address
	movwf	ebyte
	call	putbyte_1		; Output Address byte and get ACK

	return

; *******************************************************************************
; *				I2C ROUTINES					*
; *******************************************************************************
; Start condition; data goes from hi to low with SCL high
; Normal state is: SCL low, data high
i2cstart_1
	call bank1	
	bcf	TRISIO,SDA1	; SDA is output
	call bank0
	bsf	GPIO,SDA1	; Set SDA High	
	bsf	GPIO,SCL	; SCL hi
	nop
	bcf	GPIO,SDA1	; SDA low
	nop
	bcf	GPIO,SCL	; SCL low
	nop	
	bsf	GPIO,SDA1	; SDA High on exit		

        return

; *******************************************************************************	
; Output a byte in ebyte to Si5351 and then get an ACK
putbyte_1
	call bank1	
	bcf	TRISIO,SDA1	; SDA is output
	call bank0

	movlw	H'08'		; Counter
	movwf	bytcnt

	bcf	STATUS,C
senlp_1
	rlf	ebyte,f
	btfss	STATUS,C
	goto	zerb_1			
	bsf	TRISIO,SDA1	; SDA hi 
	goto	zerb1_1
zerb_1
	bcf	GPIO,SDA1	; SDA low 	
zerb1_1
	bsf	GPIO,SCL	; SCL hi
	nop
	nop
	bcf	GPIO,SCL	; SCL low
	decfsz	bytcnt,f			
	goto	senlp_1
	bsf	GPIO,SDA1	; Exit with data high
	call	getack_1

	return

; *******************************************************************************
; Read acknowledge signal from Si5351. SDA low with SCL high
getack_1
	call bank1	
	bsf	TRISIO,SDA1	; SDA is Input
	call bank0	
	bsf	GPIO,SCL	; SCL hi  
	nop
	nop		
	bcf	GPIO,SCL	; SCL low 	
	return			; With C clear if ack received, set otherwise

; *******************************************************************************
; Stop condition; data goes from low to hi with SCL high
; Normal state is: SCL low, data high
stop_1
	nop
	call bank1	
	bcf	TRISIO,SDA1	; SDA is output
        call bank0
	bcf	GPIO,SDA1	; SDA low 
	nop
	nop
	bsf	GPIO,SCL	; SCL hi  
	nop
	nop
	bsf	GPIO,SDA1	; SDA hi 
	nop
	nop
	bcf	GPIO,SCL	; SCL low

	return


	
	
	
; *******************************************************************************
; *										*
; * Purpose:	Wait for a specified number of milliseconds			*
; *										*
; *		Entry point wait_10ms : Wait for 10 msec			*
; *		Entry point wait_1ms						*
; *										*
; *   Input:	None								*
; *										*
; *  Output:	None								*
; *										*
; *******************************************************************************



wait_10ms   ; ****** Entry point ******     
	movlw	D'20'		; Set up outer loop counter to 20
	movwf	count
	goto	outer_loop	; Into the wait loops
wait_1ms
        movlw	D'2'		; Set up outer loop counter to 2
        movwf   count
;
; Wait loops used by other wait routines
;  - 1 microsecond per instruction (with a 4 MHz microprocessor clock)
;  - 498 instructions per inner loop
;  - (temp * 498) instructions (.498 msec) per outer loop
;  - Round off to .5 ms per outer loop
;
outer_loop                        
	movlw	H'A4'		; Set up inner loop counter to 165
	movwf	temp
inner_loop
	decfsz	temp,f		; Decrement inner loop counter
	goto	inner_loop	; If inner loop counter not down to zero, 
				;   then go back to inner loop again
	decfsz	count,f		; Yes, Decrement outer loop counter
	goto	outer_loop	; If outer loop counter not down to zero,
				;   then go back to outer loop again
	return			; Yes, return to caller

; *******************************************************************************		
		
		
		

bank0	        bcf STATUS,RP0      ; bank 0 
		bcf STATUS,RP1
		return
		
bank1	        bsf STATUS,RP0      ; bank 1 
		bcf STATUS,RP1
		return		
		
		END
		
